//
//  bclass.cc
//				Author Tatsuo Baba
//
#include "bclass.h"
#include "kconv.h"
void BCStr::Add(char *data,int len)
{
	if (len <= 0)
		return;

	if (m_nSize <= m_nCur + len ) {
		char *tp = new char[m_nSize+len+2048];
		if (tp == NULL) {
			if (m_pData)
				delete [] m_pData;
			throw "BCStr out of space";
		}
		if (m_pData) {
			memcpy(tp,m_pData,m_nCur);
			delete [] m_pData;
		}
		m_pData = tp;
		m_nSize = m_nSize + len + 2048;
	}
	memcpy(m_pData+m_nCur,data,len);
	m_nCur += len;
	m_pData[m_nCur] = 0;
}

void BCStr::Compact(int pos)
{
	if (pos < 0 || m_nCur <= pos || m_pData == NULL)
		return;
	memmove(m_pData,m_pData+pos,m_nCur - pos);
	m_nCur -= pos;
	m_pData[m_nCur] = 0;
}

void BCStr::Expand(int len)
{
	if (len <= 0)
		return;

	char *tp = new char[m_nSize+len];
	if (tp == NULL) {
		if (m_pData)
			delete [] m_pData;
		throw "BCStr out of space";
	}
	if (m_pData) {
		memcpy(tp,m_pData,m_nCur);
		delete [] m_pData;
	}
	m_pData = tp;
	m_nSize = m_nSize + len;
	memset(m_pData+m_nCur,0,len);
}


void BCStr::AddByte(int data)
{

	if (m_nSize <= m_nCur + 1 ) {
		char *tp = new char[m_nSize+2048];
		if (tp == NULL) {
			if (m_pData)
				delete [] m_pData;
			throw "BCStr out of space";
		}
		if (m_pData) {
			memcpy(tp,m_pData,m_nCur);
			delete [] m_pData;
		}
		m_pData = tp;
		m_nSize += 2048;
	}
	m_pData[m_nCur] = data & 0x00ff;
	m_nCur++;
	m_pData[m_nCur] = 0;
}

char* BCStr::Find(int ch)
{
	if (m_pFind || !m_pData)
		return m_pFind;
	m_pFind = Strchr(m_pData,ch);
	if (m_pFind) {
		m_pFind[0] = 0;
		m_pFind++;
	}
	return m_pFind;
}



int BFileAttr(const char* name)
{
	if (strcmp(name,"stdin") == 0)	// stdin is ok
		return 1;
	struct stat buf;
	int rc = stat(name, &buf);
	if (rc == -1)
		return rc;
	if( buf.st_mode & S_IFDIR) // dir ?
		return 0;
	return 1;
}


// 2000.01.21 add BFile class
BFile::BFile(const char* fname)
{
	if (strcmp(fname,"stdin") == 0)
		m_hFile = fdopen(0,"r");
	else
		m_hFile = fopen(fname,"r");
}
BFile::~BFile()
{
	
	Close();

}
void BFile::Close()
{
	if (m_hFile) {
		fclose(m_hFile);
		m_hFile = NULL;
	}
}
char *BFile::GetLine()
{
	if (m_hFile == NULL || fgets(m_pBuff,sizeof m_pBuff,m_hFile) == NULL)
		return NULL; 
	// 1999.07.08 Fix put CR/LF
	int len = strlen(m_pBuff);
	if (len == 0)
		return m_pBuff;
	if (m_pBuff[len-1] == '\n')
		m_pBuff[--len] = 0;
	if (m_pBuff[len-1] == '\r')
		m_pBuff[--len] = 0;
 	return 	m_pBuff;
}


char* Strrchr(const char* str,char chr) 
{
	char *tp = NULL;
	int len = strlen(str);
	for (int i = 0;i < len;i++) {
		if (iskanji(str[i])) {
			i++; continue;
		}
		if (str[i] == chr)
			tp = (char*)str + i;
	}
	return tp;
}

char* Strchr(const char* str,char chr) 
{
	int len = strlen(str);
	for (int i = 0;i < len;i++) {
		if (iskanji(str[i])) {
			i++; continue;
		}
		if (str[i] == chr)
			return (char*)str + i;
	}
	return NULL;
}

